# Usage: TIG::DefaultEdges.now
module TIG
  module DefaultEdges
    def self.now()
      model = Sketchup.active_model
      ss = model.selection
      if es = ss.grep(Sketchup::Edge) # process selected edges
        self.default_edges(es)
      end
      if gs = ss.grep(Sketchup::Group)
        self.default_groups(gs)
      end
      if cs = ss.grep(Sketchup::ComponentInstance)
        self.default_compos(cs)
      end
    end
    def self.default_edges(es) # default passed edges
      es.each{|e| e.material = nil }
    end
    def self.default_groups(gs) # nested in groups
      gs.each{|g|
        es = g.entities.grep(Sketchup::Edge)
        self.default_edges(es)
        g.entities.grep(Sketchup::Group).each{|gg| self.default_groups(gg) }
        g.entities.grep(Sketchup::ComponentInstance).each{|cc| self.default_compos(cc) }
      }
    end
    def self.default_compos(cs) # nested in definitions
      cs.each{|c|
        es = c.definition.entities.grep(Sketchup::Edge)
        self.default_edges(es)
        c.definition.entities.grep(Sketchup::Group).each{|gg| self.default_groups(gg) }
        c.definition.entities.grep(Sketchup::ComponentInstance).each{|cc| self.default_compos(cc) }
      }
    end
  end
end
